/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TIPOCONTABEM                                             */
/* Tabela : TIPOCONTABEM                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 26/03/2009 - Luciana Correa de Figueiredo                                  */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE
TRIGGER DTULTATU_TIPOCONTABEM
BEFORE INSERT OR UPDATE OR DELETE
ON TIPOCONTABEM FOR EACH ROW
BEGIN
   IF INSERTING THEN
      :NEW.DTULTATU := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF(NVL(:OLD.CDEMPRESA ,     0) <> NVL(:NEW.CDEMPRESA,      0)) OR
        (NVL(:OLD.CDTIPOCONTABEM ,0) <> NVL(:NEW.CDTIPOCONTABEM ,0)) OR
        (NVL(:OLD.NMTIPOCONTABEM ,0) <> NVL(:NEW.NMTIPOCONTABEM ,0)) OR
        (NVL(:OLD.NMABREVTPCONTA ,0) <> NVL(:NEW.NMABREVTPCONTA ,0)) THEN
        :NEW.DTULTATU := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE,CDFILICACHE,DSKEYCACHE,DTULTATUCACH)
      VALUES ('TIPOCONTABEM','','CDEMPRESA='||:OLD.CDEMPRESA||';CDTIPOCONTABEM='||:OLD.CDTIPOCONTABEM||';', SYSDATE);
   END IF;
END;
/
ALTER TABLE TIPOCONTABEM MODIFY DTULTATU DEFAULT SYSDATE
/
UPDATE TIPOCONTABEM SET DTULTATU = SYSDATE WHERE DTULTATU IS NULL
/
-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_TIPOCONTABEM','5.05.119'); END;
/

