var FooterListForm = function($scope, $rootScope) {

	$rootScope.filterFooter = $rootScope.filterFooter ? $rootScope.filterFooter : {
		showOnList: true
	};

	$scope.showOnFooter = function(item) {
		return Object.keys($rootScope.filterFooter).some(function(key) {
			return item[key];
		});
	};

	var uiChangeFooterDeregister = $rootScope.$on("ui.changeFooter", function(event, message) {
		$rootScope.filterFooter = {};
		$rootScope.filterFooter[message] = true;
	});

	var uiAddToFooterDeregister = $rootScope.$on("ui.addToFooter", function(event, message) {
		$rootScope.filterFooter = $rootScope.filterFooter || {};
		$rootScope.filterFooter[message] = true;
	});

	var uiRemoveFromFooterDeregister = $rootScope.$on("ui.removeFromFooter", function(event, message) {
		delete $rootScope.filterFooter[message];
	});

	$scope.$on('$destroy', function() {
		uiChangeFooterDeregister();
		uiAddToFooterDeregister();
		uiRemoveFromFooterDeregister();
	});
};

ZeedhiController.controller('FooterListForm', FooterListForm);